/*
 *  DialogFOpen.c
 *  Version 2.0.2 / 020706
 *  by Satoshi Takahashi
 */

#ifndef DIALOGFOPEN_C /*pragma once*/
#define DIALOGFOPEN_C
#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif
#if S_CARBON
#include <Carbon/Carbon.h>
#endif
#if XDialog
#if SunOS
#include <dirent.h>
#else
#include <sys/dir.h>
#endif
#include <sys/stat.h>
#include <X11/Intrinsic.h>
#endif/*XDialog*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if S_UNIX 
#if !UNIXMAC /*not emulate unix on Macintosh*/
#include <unistd.h> /* getcwd, chdir */
#else
#include <s_UNIX.h>
#endif
#endif

#if !S_UNIX
/*#include <Files.h>*/ /*???*/
#if !S_CARBON
#include <QDOffScreen.h>
#endif

#ifndef SCLLocal
#include <s_Drawing.h> /*s_SetGWorld*/
#else
#include "s_Drawing.h" /*s_SetGWorld*/
#endif
#endif /*!S_UNIX*/


#ifndef SCLLocal
#include <s_Carbon.h>
#include <s_CarbonMacro.h>

#include <s_String.h>
#include <DialogFOpen.h>
#include <StartSCL.h>
#include <s_Drawing.h>


#define USEHSETVOL 1

#include <VarBody.h>
#include <DialogFOpen-v.c>

#else

#include "s_Carbon.h"
#include "s_CarbonMacro.h"

#include "s_String.h"
#include "DialogFOpen.h"
#include "StartSCL.h"
#include "s_Drawing.h"


#define USEHSETVOL 1

#include "VarBody.h"
#include "DialogFOpen-v.c"

#endif


#if !S_UNIX && !S_CARBON /*use SFFullPath for Carbon*/
char* s_GetFullPath(long DirID, int vRefNum)
{
CInfoPBRec	myPB;
char	dirName[256];
static char	fullPath[256];
char	fullPath2[256];
OSErr	myErr;

	fullPath[0] = 0;
	if (DirID == fsRtParID)
		return fullPath;
	myPB.hFileInfo.ioNamePtr = (unsigned char*)dirName;
	myPB.hFileInfo.ioVRefNum = vRefNum;
	myPB.dirInfo.ioDrParID = DirID;
	myPB.dirInfo.ioFDirIndex = -1;	
	do
	{
		myPB.dirInfo.ioDrDirID = myPB.dirInfo.ioDrParID;
		myErr = PBGetCatInfoSync(&myPB);
		dirName[dirName[0]+1]=0;
		strcpy(fullPath2,dirName+1);
		strcat(fullPath2,":");
		strcat(fullPath2,fullPath);
		strcpy(fullPath,fullPath2);
	} while (myPB.dirInfo.ioDrDirID != fsRtDirID);
	return fullPath;
}
#endif /*!S_UNIX && !S_CARBON*/




FILE * DialogFOpen(const char* filename, const char* mode)
{
#if !S_UNIX
#if USEHSETVOL && !S_CARBON
short vRefNum;
long dirID;
FILE *filep;
char fileName[64];
#endif
OSType error;
Boolean good;
OSType fileType;
#if S_CARBON || !USEHSETVOL
static char path[1024];
#endif


    if ((mode[1] == 'b')||(mode[2]=='b'))
		fileType = 0;  /* any type */
    else
        fileType = 'TEXT';

	if ((mode[0] == 'r')||(mode[1]=='r')||(mode[1]=='+'))
        error = SCLGetFile(fileType, &s_df.fss, &good);
        //error = SCLGetFile(fileType, &fsr, &good);
    else
        error = SCLPutFile(filename, fileType, &s_df.fss, &good);
        //error = SCLPutFile(filename, fileType, &fsr, &good);
//printf("error = %d\n", error);
    if (error && error!=fnfErr)
        return 0;
    //s_printf("%d %20s\n", s_df.fss.name[0], s_df.fss.name + 1);

//printf("good = %d\n", good);
	if (good)
	{
#if S_CARBON
     OSErr error;
     FSRef fsr;
        error = FSpMakeFSRef(&s_df.fss, &fsr);
        //printf("error = %d\n", error);
        error = FSRefMakePath(&fsr, path, 1024);
        //printf("error = %d\n", error);
//s_printf("a");
//Stop();
//s_printf("path = %s\nmode = %s\n", path, mode);
		return fopen(path, mode);
#elif USEHSETVOL
 		P2CString(s_df.fss.name, fileName);
		HGetVol(NULL, &vRefNum, &dirID);
		HSetVol(NULL, s_df.fss.vRefNum, s_df.fss.parID);
		filep = fopen(fileName, mode);
		HSetVol(NULL, vRefNum, dirID);
		return filep;
#else
 		P2CString(s_df.fss.name, fileName);
		strcpy(path, s_GetFullPath(s_df.fss.parID, s_df.fss.vRefNum));
		strcat(path, fileName);
		return fopen(path, mode);
#endif
	}
	else
	{
		return 0;
	}
#else /*!S_UNIX*/
char pathName[512];
FILE *filep;
	
	/* save current PWD */
	getcwd(pathName, 512);
	
#if XDialog
	filep = XFOpen(filename, mode);
#else
	filep = UnixFOpen(filename, mode);
#endif
	
	chdir(pathName);

	return filep;
#endif /*else !S_UNIX*/
}



#if S_CARBON
OSErr SCLGetFile(OSType fileType, FSSpec *fssP, Boolean *goodP)
//OSErr SCLGetFile(OSType fileType, FSRef *fsrP, Boolean *goodP)
{
NavReplyRecord reply;
NavTypeListHandle typeListH;
NavDialogOptions option;
OSErr error;
DescType rtype;
AEKeyword key;
Size len;
GWorldPtr currPort;
GDHandle currDev;

    NavGetDefaultDialogOptions(&option);
    option.dialogOptionFlags += + kNavNoTypePopup - kNavAllowMultipleFiles;
    C2PString(s_df.clientName, option.clientName);
    
    if (!fileType)
    {
        typeListH = 0;
    }
    else
    {
        typeListH = (NavTypeListHandle)NewHandle(sizeof(NavTypeList)
                                                    + 1*sizeof(OSType));
        typeListH[0]->componentSignature = kNavGenericSignature;
        typeListH[0]->osTypeCount = 2;
        typeListH[0]->osType[0] = fileType;
        /*files of OS X mostly have 0 File Type :-( */
        typeListH[0]->osType[1] = 0;
    }

	s_GetGWorld((GrafPtr*)&currPort,&currDev);
	if (s_displayWindow)
		s_SetGWorld(GetWindowPort(s_displayWindow),s_display);

    error = NavGetFile(s_df.defaultLocation, &reply, &option, 0, 0, 0, typeListH, 0);

	s_SetGWorld((GrafPtr)currPort, currDev);

    if (error)
        return error;
    
    *goodP = reply.validRecord;
    if (!reply.validRecord)
        return -1;
    
    error = AEGetNthPtr(&(reply.selection), 1, typeFSS, &key, &rtype, (Ptr)fssP,
        (long)sizeof(FSSpec), &len);
    //error = AEGetNthPtr(&(reply.selection), 1, typeFSRef, &key, &rtype, (Ptr)fsrP,
        //(long)sizeof(FSSpec), &len);
    NavDisposeReply(&reply);
    return error;
}

OSErr SCLPutFile(const char *filename, OSType fileType,
    FSSpec *fssP, Boolean *goodP)
//OSErr SCLPutFile(const char *filename, OSType fileType,
    //FSRef *fsrP, Boolean *goodP)
{
NavReplyRecord reply;
NavDialogOptions option;
OSErr error;
DescType rtype;
AEKeyword key;
Size len;
GWorldPtr currPort;
GDHandle currDev;

	s_GetGWorld((GrafPtr*)&currPort,&currDev);
	if (s_displayWindow)
		s_SetGWorld(GetWindowPort(s_displayWindow),s_display);

    NavGetDefaultDialogOptions(&option);
    option.dialogOptionFlags += + kNavNoTypePopup - kNavAllowMultipleFiles;
    C2PString(s_df.clientName, option.clientName);
    
    if (!fileType)
        fileType = 'BINA';
    C2PString(filename, option.savedFileName);
    error = NavPutFile(s_df.defaultLocation, &reply, &option, 0, fileType, kNavGenericSignature, 0);

	s_SetGWorld((GrafPtr)currPort, currDev);

    if (error)
        return error;
    
    *goodP = reply.validRecord;
    if (!reply.validRecord)
        return -1;
    
    error = AEGetNthPtr(&(reply.selection), 1, typeFSS, &key, &rtype, (Ptr)fssP,
        (long)sizeof(FSSpec), &len);
    //error = AEGetNthPtr(&(reply.selection), 1, typeFSRef, &key, &rtype, (Ptr)fsrP,
        //(long)sizeof(FSSpec), &len);
    NavDisposeReply(&reply);
    FSpDelete(fssP);
    FSpCreate(fssP, 'SCL ', 'TEXT', smSystemScript);
    return error;
}

#elif !S_UNIX /*S_CARBON*/

OSErr SCLGetFile(OSType fileType, FSSpec *fssP, Boolean *goodP)
{
StandardFileReply reply;
SFTypeList fileTypeList;
short numType;
GWorldPtr currPort;
GDHandle currDev;

    if (!fileType)
        numType = -1;  /* any type */
    else
    {
        fileTypeList[0] = fileType;
        fileTypeList[1] = 0; /*deal with files from OS X*/
        numType = 2;
    }

#if SCL_USE_WINDOW
	s_GetGWorld((GrafPtr*)&currPort,&currDev);
	if (s_displayWindow)
		s_SetGWorld(GetWindowPort(s_displayWindow),s_display);
#endif
    StandardGetFile( nil, numType, fileTypeList, &reply);
#if SCL_USE_WINDOW
	s_SetGWorld((GrafPtr)currPort, currDev);
#endif
    
    *fssP = reply.sfFile;
    *goodP = reply.sfGood;
    return 0;
}


OSErr SCLPutFile(const char *filename, OSType fileType,
    FSSpec *fssP, Boolean *goodP)
{
StandardFileReply reply;
Str255 pfilename;
GWorldPtr currPort;
GDHandle currDev;

    C2PString(filename, pfilename);

#if SCL_USE_WINDOW
	s_GetGWorld((GrafPtr*)&currPort,&currDev);
	if (s_displayWindow)
		s_SetGWorld(GetWindowPort(s_displayWindow),s_display);
#endif
    StandardPutFile("\p Save file as:", pfilename, &reply);
#if SCL_USE_WINDOW
	s_SetGWorld((GrafPtr)currPort, currDev);
#endif
 
    *fssP = reply.sfFile;
    *goodP = reply.sfGood;
    return 0;
}
#endif /*else S_CARBON*/

#if !S_UNIX
FSSpec DialogFSSpec(void)
{
FSSpec emptySpec = {0, 0, ""};
OSType error;
Boolean good;

    error = SCLGetFile(0, &s_df.fss, &good);
	if (error || !good)
		return emptySpec;
	else
		return s_df.fss;
}
#endif /*elif !S_UNIX if S_CARBON*/

#if S_UNIX
#if XDialog

#ifndef DITLITEM
#define DITLITEM(dialog) \
(((ItemList*)(((DialogPeek)dialog)->items))->DITLItems)
#endif

#define SXDFFileIDStart 8
#define SXDFDirPathID	7
#define SXDFListSize 16 /*number of file list items on dialog*/
#define PutOpenButton 40
#define PutNameField 41

char putFileName[256];

FILE *XFOpen(char const *filename, char const *mode)
{
DialogPtr dialog;
int getFlag;
int dirChanged = 1;
char dirPath[512];
DIR *dir = 0;
int fStart;
int fTotal;
short selectID;
short itemHit;
short iType;
Rect iRect;
Handle iHandle;
DITLItem *dItem;
String selectName;
int openButtonHit = 0;

	getFlag = (mode[0] == 'r')||(mode[1]=='r')||(mode[1]=='+');
	if (getFlag)
		dialog = GetNewDialog(1, 0, 0);
	else
		dialog = GetNewDialog(2, 0, 0);

	SelectWindow(dialog);
	ShowWindow(dialog);
	dItem = DITLITEM(dialog);
	if (!getFlag)
	{
		C2PString(filename, putFileName);
		XtVaSetValues(dItem[PutNameField].widget, XtNstring, putFileName, 0);
		XtVaSetValues(dItem[PutNameField].widget, XtNlength, 255, 0);
	}
	
	while (1)
	{
		if (dirChanged)
		{
			dirChanged = 0;
			if (dir)
				closedir(dir);
			getcwd(dirPath, 512);
			dir = opendir(dirPath);
			GetDialogItem(dialog, SXDFDirPathID, &iType, &iHandle, &iRect);
			SetDialogItemText(iHandle, dirPath);
			fStart = 0;
			fTotal = SXCountFilesInDir(dir);
			selectID = 0;
		}

		if (!selectID) /*if the list modified we select none for simplicity*/
			SXSetDialogFileList(dialog, dItem, dir, fStart, getFlag);	

		openButtonHit = 0;
		
		ModalDialog(0, &itemHit);

		switch (itemHit)
		{
		case 2: /*Cancel*/
			HideWindow(dialog);
			return 0;
			break;
		case 3: /*Root*/
			chdir("/");
			dirChanged = 1;
			break;
		case 4: /*Up*/
			chdir("..");
			dirChanged = 1;
			break;
		case 5: /*downArrow*/
			fStart += SXDFListSize;
			if (fStart >= fTotal)
				fStart = fTotal-1;
			selectID = 0;
			break;
		case 6:
			fStart -= SXDFListSize;
			if (fStart < 0)
				fStart = 0;
			selectID = 0;
			break;
		case 1: /*Open in get, Save in put*/
			if (!getFlag)
			{
				HideWindow(dialog);
				return fopen(putFileName, mode); /*if put just Save*/
			}
			/*continues*/
		case PutOpenButton:/*should be modified later, Open in put*/
			openButtonHit = 1;
		default:
			if ((openButtonHit && selectID)
					|| (selectID == itemHit))
			{
				XtVaGetValues(dItem[selectID].widget,
						 XtNlabel, &selectName, 0);
				if (SXIsDir(selectID, dItem))
				{
					chdir(selectName);
					dirChanged = 1;
				}
				else
				{
					HideWindow(dialog);
					return fopen(selectName, mode);
				}
			}
			if (!openButtonHit)
				selectID = itemHit;
			break;
		}
	}
}


int SXCountFilesInDir(DIR *dir)
{
int count = 0;

	rewinddir(dir);
	while (readdir(dir))
		count++;
	return count;
}


void SXSetDialogFileList(DialogPtr dialog, DITLItem *dItem,
			 DIR *dir, int fStart, int getFlag)
{
struct dirent *dirItem = (struct dirent *)1;
int i;
struct stat fStat;

	rewinddir(dir);
	for (i = 0; i < fStart; i++)
		readdir(dir);

	for (i = 0; i < SXDFListSize; i++)
	{
		XtVaSetValues(dItem[SXDFFileIDStart+2*i].widget,
			XtNstate, 0, 0);
		
		if (dirItem)
			dirItem = readdir(dir);

		if (dirItem)
		{
			XtVaSetValues(dItem[SXDFFileIDStart+2*i].widget,
				XtNlabel, dirItem->d_name, 0);
			stat(dirItem->d_name, &fStat);
			if ((fStat.st_mode & S_IFMT) == S_IFDIR) /*directory*/
			{
				XtSetSensitive(dItem[SXDFFileIDStart+2*i].widget,
						1);
				XtVaSetValues(dItem[SXDFFileIDStart+2*i+1].widget,
						XtNlabel, "/", 0);
			}
			else
			{
				XtSetSensitive(dItem[SXDFFileIDStart+2*i].widget,
						getFlag);
				XtVaSetValues(dItem[SXDFFileIDStart+2*i+1].widget,
						XtNlabel, "", 0);
			}
		}
		else
		{
			XtVaSetValues(dItem[SXDFFileIDStart+2*i].widget,
					XtNlabel, "", 0);
			XtSetSensitive(dItem[SXDFFileIDStart+2*i].widget,
					0);
			XtVaSetValues(dItem[SXDFFileIDStart+2*i+1].widget,
					XtNlabel, "", 0);
		}
	}
}


int SXIsDir(int selectID, DITLItem *dItem)
{
String label;

	XtVaGetValues(dItem[selectID+1].widget, XtNlabel, &label, 0);
	return (label[0] == '/');
}

#else /*XDialog*/
FILE *UnixFOpen(char const *fileName, char const *mode)
{
int exitFlag = 1;
char oneLine[512];

	while (exitFlag)
	{
		s_printf("Enter file name (default %s) or !(toggle command mode): ", fileName);
		fgets(oneLine, 512, stdin);
		if (oneLine[strlen(oneLine)-1] == '\n')
			oneLine[strlen(oneLine)-1] = 0;
		
		if (oneLine[0] == '!')
			UnixCommand();
		else
		{
			if (oneLine[0] == 0)
				return fopen(fileName, mode);
			else
			{
				return fopen(oneLine, mode);
			}	
			break;
		}	
	}
}

void UnixCommand(void)
{
int ret;
char oneLine[512];

	while (1)
	{
		s_printf("> ");
		fgets(oneLine, 512, stdin);
		if (oneLine[strlen(oneLine)-1] == '\n')
			oneLine[strlen(oneLine)-1] = 0;
		
		if (oneLine[0] == '!')
			break;
		else
		if (!strncmp(oneLine, "cd ", 3))
		{
			ret = chdir(oneLine + 3);
			if (ret)
				perror("SCL-UnixCommand");
		}
		else
			system(oneLine);
	}
}
#endif /*else UNIX*/

#endif /*S_UNIX*/


#if S_CARBON
void SetDefaultFileLocation(FSSpec *fssP)
{
    s_df.defaultLocation = malloc(sizeof(AEDesc));
    AECreateDesc(typeFSS, fssP, sizeof(FSSpec), s_df.defaultLocation);
}
#endif /*S_CARBON*/

#endif /*pragma once*/
