/*
 *  EPS.c
 *  project
 *
 *  Created by Satoshi Takahashi on Fri Nov 01 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */


#ifndef EPS_C /*pragma once*/
#define EPS_C

#include <string.h>

#include <s_Config.h>

#if S_CARBON
#include <Carbon/Carbon.h>
#endif

#include <s_Drawing.h>

#include <EPS.h>

#include <VarBody.h>
#include <EPS-v.c>

void BeginEPSSaving(void)
{
    BeginEPSSavingBox(0, 0, DrawingWidth(), DrawingHeight());
}


void BeginEPSSavingBox(short left, short bottom, short right, short top)
{
    s_eps.file = fopen("/tmp/SCL-tmp.eps", "w");
    if (!s_eps.file)
        return;
    s_eps.saving = 1;
    
    //fprintf(s_eps.file, "%%!PS-Adobe-3.0 EPSF-3.0\n");
    //fprintf(s_eps.file, "%%%%BoundingBox: %hd %hd %d %hd\n",
                //left, bottom, right, top);

    fprintf(s_eps.file, "/Times findfont\n");
    fprintf(s_eps.file, "12 scalefont setfont\n");
    fprintf(s_eps.file, "1 -1 scale\n");
    fprintf(s_eps.file, "0 %d translate\n", -top);
    fprintf(s_eps.file, "1 setlinecap\n");
}


void EndEPSSaving(void)
{
FILE *fp, *ftmp;
Rect r;
char buf[1024];
size_t rc;

    if (!s_eps.saving)
        return;
    s_eps.saving = 0;
    fclose(s_eps.file);
    fp = DialogFOpen(s_eps.name, "w");
    if (fp)
    {
        EPSGetImageRect(&r);
        fprintf(fp, "%%!PS-Adobe-3.0 EPSF-3.0\n");
        fprintf(fp, "%%%%BoundingBox: %hd %hd %d %hd\n",
                    r.left, DrawingHeight() - r.bottom,
                    r.right, DrawingHeight() - r.top);
        ftmp =  fopen("/tmp/SCL-tmp.eps", "r");
        while (rc = fread(buf, 1, 1024, ftmp))
            fwrite(buf, 1, rc, fp);
        fclose(fp);
        fclose(ftmp);
    }
    remove("/tmp/SCL-tmp.eps");
}


void EPSBitMapSave(int bit, int color, double threshold)
{
Rect imageRect, curRect;
EventRecord event;
int i, x, y, x2, y2;

    
#if !S_UNIX
    for (i = 0; i < 100; i++)
        EventAvail(0, &event);
#endif
    EPSGetImageRect(&imageRect);
    BeginEPSSavingBox(0, 0, imageRect.right - imageRect.left,
                        imageRect.bottom - imageRect.top);
    for (x = imageRect.left; x < imageRect.right; x += EPSSTEP)
        for (y = imageRect.top; y < imageRect.bottom; y += EPSSTEP)
        {
            x2 = x + EPSSTEP;
            y2 = y + EPSSTEP;
            if (x2 > imageRect.right)
                x2 = imageRect.right;
            if (y2 > imageRect.bottom)
                y2 = imageRect.bottom;
            SetRect(&curRect, x, y, x2, y2);
            EPSBitMapProlog(bit, color, &curRect, &imageRect);
            EPSBitMapMain(bit, color, &curRect, threshold);
            EPSBitMapEpilog(bit, color);
        }
    EndEPSSaving();
}


void EPSGetImageRect(Rect *imageRectP)
{
short x, y;
RGBColor pixel;
Rect pr;

    imageRectP->left = 0;
    imageRectP->right = 0;
    imageRectP->top = 0;
    imageRectP->bottom = 0;
    //for (x = 0; x < DrawingWidth(); x++)
    //for (y = 0; y < DrawingHeight(); y++)
    GetPortBounds(GetQDGlobalsThePort(), &pr);
    for (x = 0; x < pr.right; x++)
    for (y = 0; y < pr.bottom; y++)
    {
        GetCPixel(x, y, &pixel);
        if ((pixel.red < 65535) || (pixel.green < 65535)
                || (pixel.blue < 65535))
        {
            imageRectP->left = x;
            goto label1;
        }
    }
    
    label1:
    for (y = 0; y < pr.bottom; y++)
    for (x = imageRectP->left; x < pr.right; x++)
    {
        GetCPixel(x, y, &pixel);
        if ((pixel.red < 65535) || (pixel.green < 65535)
                || (pixel.blue < 65535))
        {
            imageRectP->top = y;
            goto label2;
        }
    }

    label2:
    for (x = pr.right - 1; x >= 0 ; x--)
    for (y = imageRectP->top; y < pr.bottom; y++)
    {
        GetCPixel(x, y, &pixel);
        if ((pixel.red < 65535) || (pixel.green < 65535)
                || (pixel.blue < 65535))
        {
            imageRectP->right = x+1;
            goto label3;
        }
    }
    
    label3:
    for (y = pr.bottom - 1; y >= 0; y--)
    for (x = imageRectP->left; x < imageRectP->right ; x++)
    {
        GetCPixel(x, y, &pixel);
        if ((pixel.red < 65535) || (pixel.green < 65535)
                || (pixel.blue < 65535))
        {
            imageRectP->bottom = y+1;
            goto label4;
        }
    }
        
	label4:
	return;
}


void EPSBitMapProlog(int bit, int color, Rect *imageRectP, Rect *boundsRectP)
{
    //s_printf("%hd %hd %hd %hd\n", imageRect.left,  imageRect.top, imageRect.right, imageRect.bottom);
    
    if (!s_eps.file)
        return;
    fprintf(s_eps.file, "%hd %hd %hd\n",
                imageRectP->right - imageRectP->left,
                imageRectP->bottom - imageRectP->top,
                bit /*bit per pixel per color*/);
    fprintf(s_eps.file, "[%hd %hd %hd %hd %hd %hd]\n",
                1, 0,
                0, 1,
                - imageRectP->left, 2*boundsRectP->top - imageRectP->top);
#if 0
    fprintf(s_eps.file, "[%hd %hd %hd %hd %hd %hd]\n",
                1, 0,
                0, -1,
                0, imageRectP->bottom - imageRectP->top);
#endif
    fprintf(s_eps.file, "{<\n");
}


void EPSBitMapMain(int bit, int color, Rect *imageRectP, double threshold)
{
RGBColor pixel;
short x, y;
long count = 0;
int bitPos = 0;
unsigned int byteData = 0;
unsigned short bright;
int rgb = 0;
unsigned int unit;

    unit = 32768U >> (unsigned)(bit-1);
    
    for (y = imageRectP->top; y < imageRectP->bottom ; y++)
    {
        for (x = imageRectP->left; x < imageRectP->right ; x++)
        {
            GetCPixel(x, y, &pixel);
            for (rgb = 0; rgb < 3; rgb++)
            {
                byteData <<= bit;
    
                if (color)
                {
                    if (rgb == 0)
                        byteData += pixel.red/unit;
                    else if (rgb == 1)
                        byteData += pixel.green/unit;
                    else if (rgb == 2)
                        byteData += pixel.blue/unit;
                }
                else
                {
                    bright = 0.299*pixel.red + 0.587*pixel.green
                                + 0.114*pixel.blue;
                    if (bit == 1)
                        byteData += (bright >= (65536.0*threshold) );
                    else
                        byteData += bright/unit;
                }
    
                bitPos += bit;
                if (bitPos >= 8)
                {
                    //s_printf("%01X\n", byteData);
                    fprintf(s_eps.file, "%02X", byteData);
                    count++;
                    if (!(count%30))
                    {
                        fprintf(s_eps.file, "\n");
                    }
                    bitPos = 0;
                    byteData = 0;
                }
                if (!color)
                    break;
            }
        }
        if (bitPos)
        {
            byteData <<= (8 - bitPos);
            fprintf(s_eps.file, "%02X", byteData);
            bitPos = 0;
            byteData = 0;
        }
        if (count%30)
            fprintf(s_eps.file, "\n");
        count = 0;
    }
}


void EPSBitMapEpilog(int bit, int color)
{
    fprintf(s_eps.file, ">}\n");
    if (color)
    {
        fprintf(s_eps.file, "false %hd\n", /*false means write color data for each pixel*/
                        3 /*num of componet*/);
        fprintf(s_eps.file, "colorimage\n");
    }
    else if (bit > 1)
    {
        fprintf(s_eps.file, "false %hd\n", /*false means write color data for each pixel*/
                        1 /*num of componet*/);
        fprintf(s_eps.file, "colorimage\n");
    }
    else
        fprintf(s_eps.file, "image\n");
    //fclose(s_eps.file);
    //s_eps.saving = 0;
}


void SetEPSFileName(const char *inFileName)
{
char tmpFileName[32];
int i;

    strncpy(tmpFileName, inFileName, 27);
    tmpFileName[27] = 0;
    
    for (i=26; i >=0; i--)
    {
        if (tmpFileName[i] == '.')
        {
            tmpFileName[i] = 0;
            break;
        }
    }
    
    sprintf(s_eps.name, "%s.eps", tmpFileName);
}


    
#endif /*ndef EPS_C*/
