/*
 *  Graph2D.h
 *  Version 1.9.1 / 010304
 *  by Tomohiro Mizuno, Satoshi Takahashi, Yumiko Takahashi and Jiro Kikuchi
 */

#ifndef GRAPH2D_H /*pragma once*/
#define GRAPH2D_H


#include <Graph2D-Switches.h>
#include <ParametersDialog.h>
#include <s_QDGlobal.h>

#define G2D_MAX_FUNC_NUM 10

typedef double (*(s_g2d_fType))(double, double);

#include <VarHeader.h>
#include <Graph2D-v.c>

extern RgnHandle rt, rv, rp;

#define NewPattern(i) SetPattern(s_g2d.pat,i) /*for compatibility*/

#ifndef Graph2DF
#define Graph2DF Graph2DFunction
#endif

void Graph2DFunction(void);
void Graph2DFAddParameters(void);

#if CL
extern int *s_g2dArray;

void Graph2DMaxAndMin(void);
void Graph2DMakeArray(void);
void Graph2DInitArray(void);
void ContourLabel(double labelValue);
#endif

#if MOVEPOLY
void DefineTriangle(double x0, double y0 , double x1, double y1, double x2, double y2,
						PolyHandle *tri);
#endif

void LevelLineTriangle
	( double x1, double y1, double x2, double y2, double x3, double y3,
		double fmin, double fav, double fmax);

void Graph2DOrderPoints(double *x0p, double *y0p, double *x1p, double *y1p,
					double *x2p, double *y2p, double *fminp, double *favp, double *fmaxp,
					int funci);

void ExchangeDouble(double *r1p, double *r2p);

#if MOVEPOLY
void PaintNegativeTriangle(double x0, double y0 , double x1, double y1, double x2, double y2,
							double fmin, double fav, double fmax, PolyHandle tri);
#else
void PaintNegativeTriangle
	(double x0, double y0 , double x1, double y1, double x2, double y2,
		double fmin, double fav, double fmax);
#endif
#if 0
void Graph2DPlotFrame();
#endif

#ifndef SetGraph2DFunc
#define SetGraph2DFunc SetGraph2DFunction
#endif
#ifndef AddGraph2DFunc
#define AddGraph2DFunc AddGraph2DFunction
#endif

void SetGraph2DFunction( double (*fp)(double, double) );
void AddGraph2DFunction( double (*fp)(double, double) );
void SetGraph2DDXYF(double dx, double dy, double df);
void SetGraph2DContourLabelFlag(int flag);
void SetGraph2DPaintNegativeFlag(int flag);
#define SetGraph2DPictureSize(width, height) SetGraph2DWidthHeight(width, height)
	/* for compatibility to Jiro */

#define Graph2DAddParameter(p,type,com) in_Graph2DAddParameter((Ptr)p,type,com)
void in_Graph2DAddParameter(Ptr p,int type,char* com);

void SG2DResetArray(void);

void ExtraHeightNew(void);
double Graph2DHeight(int penX, int penY);
void ExtraHeightDraw(int count);
void ResetExtraHeight(void);

void SetGraph2DOnlyZero(int onlyZero);
#endif /*pragma once*/