/*
 *  Graph3D.h
 *  Version 1.9 / 010201
 *  by Satoshi Takahashi
 */

#ifndef GRAPH3D_H /*pragma once*/
#define GRAPH3D_H

#include <VarHeader.h>
#include <Graph3D-v.c>

typedef struct g3dfType
{
	double  xh, yh, xv, yv;
	double	zView, zfView;
	double	real_center, imag_center;
	double xStart;
	double xEnd;
	double xInc;
	int xSign;
	double yStart;
	double yEnd;
	double yInc;
	int ySign;
	double *oldFArray;
} g3dfType;

#ifndef Graph3DF
#define Graph3DF Graph3DFunction
#endif

void Graph3DFunction(void);

void SG3DSetting(g3dfType *g3dfP);

double SG3DX(double x, double y, g3dfType *g3dfP);
double SG3DY(double x, double y, double z, g3dfType *g3dfP);

#ifndef SetGraph3DFunc
#define SetGraph3DFunc SetGraph3DFunction
#endif
#ifndef SetGraph3DColorFunc
#define SetGraph3DColorFunc SetGraph3DColorFunction
#endif

void SetGraph3DFunction(double(*)(double,double));

#define Graph3DAddParameter(p,type,com) in_Graph3DAddParameter((Ptr)p,type,com)
void in_Graph3DAddParameter(Ptr p,int type,char* com);

void SetGraph3DColorFunction( int (*fp)(double, double, double, double) );

void Graph3DFAddParameters(void);
void SG3DFrame(g3dfType *g3dfP);
void DrawValue(short x, short y, int digit, double value);
void DrawLabel(short x, short y, char *label);
void SG3DMakeArray(g3dfType *g3dP);
void G3DDrawArrow(double x1, double y1, double f1,
					double x2, double y2, double f2, g3dfType *g3dfP);

#endif /*pragma once*/