/*
 *  ParametersDialog.c
 *  Version 2.0 / 010824
 *  by Satoshi Takahashi
 */

#ifndef PARAMETERSDIALOG_C /*pragma once*/
#define PARAMETERSDIALOG_C
#include <s_Config.h>

/* Debug code */
#if PD_DEBUG
#define dp(d) (d,Stop())
#else
#define dp(d)
#endif

#define S_SUB /* obsolete ?*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include <StartSCL.h>
/* #include <ParametersDialog-private.h> obsolete */
#include <ParametersDialog.h>
#include <s_Common.h>
#include <s_String.h>

#if !S_UNIX
#include <DialogFOpen.h>
#endif

#include <s_undef.c>

#define ParamStart 4

#include <VarBody.h>
#include <ParametersDialog-v.c>



PDSet*	s_paramDialogP; /*s_paramDialog;*/

typedef struct s_PDTypePair
{
	char	*typeName;
	int		typeNum;
}	s_PDTypePair;

s_PDTypePair s_PDTypePairTable[] =
{
	{"intType", 			intType},
	{"staticIntType",		staticIntType},
	{"longType", 			longType},
	{"shortType", 			shortType},

	{"doubleType", 			doubleType},
	{"expType", 			expType},

	{"stringType", 			stringType},
	{"staticStringType",	staticStringType},

	{"flagType", 			flagType},
	{"doType", 				doType},

	{0, 					0},
};



void in_SetUpParametersDialogP(PDSet** s_paramDialogPP)
{
	if (s_PD.setupFlag)
		PrintError("Error in SetUpParametersDialog:\nSecond call");
	s_PD.setupFlag = 1;
	
	if (!(*s_paramDialogPP = (PDSet*)malloc(sizeof(PDSet))))
		s_OOMError();
	if (!(s_paramDialogPP[0]->dialog = GetNewDialog(128, nil, (WindowPtr)-1)))
    {
		s_OOMError();
    }
	s_paramDialogPP[0]->paramNum = 0;
	s_paramDialogPP[0]->textStart = 0;
	s_paramDialogPP[0]->prev = 0;
	s_paramDialogPP[0]->next = 0;
	
}


void in_AddParameterP0(Ptr p,int type,char* com,PDSet** s_paramDialogP)
{
	if ( !*s_paramDialogP )
		 in_SetUpParametersDialogP(s_paramDialogP);

	in_AddParameterP(p,type,com,*s_paramDialogP);
}

void in_AddParameterP(Ptr p,int type,char* com,PDSet* s_paramDialog)
{
short iType;
Rect iRect;
PDSet* curPDP;
Handle iHandle;

	if ( !s_paramDialog )
	{
		s_printf("Error: ParametersDialog not initialized\n");
		Stop();
		exit(-1);
	}

	curPDP = s_paramDialog;
	while ( curPDP->next ) curPDP = curPDP->next;
	
	if (curPDP->paramNum >= MaxPNum)
	{
		curPDP->next = (PDSet*)malloc(sizeof(PDSet));
		curPDP->next->prev=curPDP;
		GetDialogItem(curPDP->dialog,57,&iType,&iHandle,&iRect);
		DisposeHandle(iHandle);
		iType = ctrlItem|btnCtrl;
		iHandle = (Handle)NewControl(GetDialogWindow(curPDP->dialog), &iRect,
#if !S_UNIX
					"\p>>",
#else
					">>",
#endif
					TRUE, 1, 0, 1, btnCtrl, 1);
		SetDialogItem(curPDP->dialog, 57,iType,iHandle,&iRect);
		curPDP = curPDP->next;
		if (!(curPDP->dialog = GetNewDialog(128,nil,(WindowPtr)-1)))
			s_OOMError();
		curPDP->paramNum = 0;
		curPDP->textStart = 0;
		curPDP->next = 0;		
		GetDialogItem(curPDP->dialog,56,&iType,&iHandle,&iRect);
		DisposeHandle(iHandle);
		iType = ctrlItem|btnCtrl;
		iHandle = (Handle)NewControl(GetDialogWindow(curPDP->dialog), &iRect,
#if !S_UNIX
						"\p<<",
#else
						"<<",
#endif
						TRUE, 1, 0, 1, btnCtrl, 1);
		SetDialogItem(curPDP->dialog,56,iType,iHandle,&iRect);
	}
	curPDP->paramList[curPDP->paramNum].p = p;
	curPDP->paramList[curPDP->paramNum].type = type;

	strcpy(curPDP->paramList[curPDP->paramNum].comstr,com);

#if !S_UNIX || XDialog
	C2PString(curPDP->paramList[curPDP->paramNum].comstr,curPDP->paramList[curPDP->paramNum].com);
	switch (type)
	{
	case intType : 
	case staticIntType:
		curPDP->paramList[curPDP->paramNum].val.intV = *(int*)p;
		sprintf(curPDP->paramList[curPDP->paramNum].valstr,"%d",curPDP->paramList[curPDP->paramNum].val.intV);
		break;
	case longType:
		curPDP->paramList[curPDP->paramNum].val.longV = *(long*)p;
		sprintf(curPDP->paramList[curPDP->paramNum].valstr,"%ld",curPDP->paramList[curPDP->paramNum].val.longV);
		break;
	case shortType:
		curPDP->paramList[curPDP->paramNum].val.shortV = *(short*)p;
		sprintf(curPDP->paramList[curPDP->paramNum].valstr,"%hd",curPDP->paramList[curPDP->paramNum].val.shortV);
		break;
	case doubleType:
		(curPDP->paramList)[curPDP->paramNum].val.doubleV = *(double*)p;
		sprintf((curPDP->paramList)[curPDP->paramNum].valstr,"%f",(double)((curPDP->paramList)[curPDP->paramNum].val.doubleV));
		break;
	case expType: 
		(curPDP->paramList)[curPDP->paramNum].val.doubleV = *(double*)p;
		sprintf((curPDP->paramList)[curPDP->paramNum].valstr,"%e",(double)((curPDP->paramList)[curPDP->paramNum].val.doubleV));
		break;
	case stringType:
	case staticStringType:
		curPDP->paramList[curPDP->paramNum].val.stringV = (char*)p;
		sprintf(curPDP->paramList[curPDP->paramNum].valstr,curPDP->paramList[curPDP->paramNum].val.stringV);
		break;						
	case flagType:
		curPDP->paramList[curPDP->paramNum].val.intV = *(int*)p;
		break;
	case doType:
		curPDP->paramList[curPDP->paramNum].val.func = (void (*)(void))p;
		break;						
	default:;
	}
	GetDialogItem(curPDP->dialog,ParamStart+2*curPDP->paramNum,&iType,&iHandle,&iRect);
	SetDialogItemText(iHandle,curPDP->paramList[curPDP->paramNum].com);
	switch (type)
	{
	case intType:
	case longType:
	case shortType:
	case doubleType:
	case expType: 
	case stringType:
		C2PString(curPDP->paramList[curPDP->paramNum].valstr,curPDP->paramList[curPDP->paramNum].valpstr);
		GetDialogItem(curPDP->dialog,ParamStart+2*curPDP->paramNum+1,&iType,&iHandle,&iRect);
		iType = editText | itemDisable;
		SetDialogItem(curPDP->dialog,ParamStart+2*curPDP->paramNum+1,iType,iHandle,&iRect);
		SetDialogItemText(iHandle,curPDP->paramList[curPDP->paramNum].valpstr);
		break;
	case staticIntType:
	case staticStringType:
		C2PString(curPDP->paramList[curPDP->paramNum].valstr,curPDP->paramList[curPDP->paramNum].valpstr);
		GetDialogItem(curPDP->dialog,ParamStart+2*curPDP->paramNum+1,&iType,&iHandle,&iRect);
		iType = statText | itemDisable;
		SetDialogItem(curPDP->dialog,ParamStart+2*curPDP->paramNum+1,iType,iHandle,&iRect);
		SetDialogItemText(iHandle,curPDP->paramList[curPDP->paramNum].valpstr);
		if (curPDP->paramNum==curPDP->textStart) curPDP->textStart++;
		break;
	case flagType:
		GetDialogItem(curPDP->dialog,ParamStart+2*curPDP->paramNum+1,&iType,&iHandle,&iRect);
		DisposeHandle(iHandle);
		iType = ctrlItem|chkCtrl;
		iHandle = (Handle)NewControl(GetDialogWindow(curPDP->dialog), &iRect,
#if !S_UNIX
							"\p",
#else
							"",
#endif
							TRUE,curPDP->paramList[curPDP->paramNum].val.intV,
							0,1,chkCtrl,1);
		SetDialogItem(curPDP->dialog,ParamStart+2*curPDP->paramNum+1,iType,iHandle,&iRect);
		if (curPDP->paramNum==curPDP->textStart) curPDP->textStart++;
		break;
	case doType:
		GetDialogItem(curPDP->dialog,ParamStart+2*curPDP->paramNum+1,&iType,&iHandle,&iRect);
		DisposeHandle(iHandle);
		iType = ctrlItem|btnCtrl;
		iRect.right-=30;
		/*InsetRect(&iRect,15,0);*/
		iHandle = (Handle)NewControl(GetDialogWindow(curPDP->dialog), &iRect,
#if !S_UNIX
							"\pDo",
#else
							"Do",
#endif
							TRUE, curPDP->paramList[curPDP->paramNum].val.intV, 0, 1, btnCtrl, 1);
		SetDialogItem(curPDP->dialog, ParamStart+2*curPDP->paramNum+1, iType, iHandle, &iRect);
		if (curPDP->paramNum==curPDP->textStart) curPDP->textStart++;
		break;
	default:;
	}
#endif /*!S_UNIX || XDialog*/

	curPDP->paramNum++;

	CheckPause();
}


void ParametersDialogP(PDSet* s_paramDialog)
{
short	itemHit;

PDSet* curPDP;

#if !S_UNIX || XDialog
#ifdef NO_FORE_DRAW
GrafPtr currPort;
GDHandle currDev;
#endif /*def NO_FORE_DRAW*/
#endif /*!S_UNIX || XDialog*/

#if S_UNIX
int panelNum = 0;
char reply[256];
#endif /*S_UNIX*/


#if S_UNIX && XDialog
	if (s_Config.XFlag)
#endif /*S_UNIX && XDialog*/

#if !S_UNIX || XDialog /*XDialog use Dialog on X Window*/
	{

#ifdef NO_FORE_DRAW
		s_GetGWorld(&currPort,&currDev);
		s_SetGWorld(s_redrawWindow,s_display);
#endif /*def NO_FORE_DRAW*/

		SetPDValues(s_paramDialog);
		s_PD.curTopPDP = s_paramDialog;
	
		curPDP = s_paramDialog;
			
		if (s_PD.loadParamFlag)
			PDInitLoadParams(); /* load parameters from initial file */
	
	restart:
		
		SelectDialogItemText(curPDP->dialog, ParamStart+2*curPDP->textStart+1, 0, 32767);
	
		SelectWindow(GetDialogWindow(curPDP->dialog));
		ShowWindow(GetDialogWindow(curPDP->dialog));
	
		itemHit = PDModalDialog(curPDP);
	
		HideWindow(GetDialogWindow(curPDP->dialog));
	
		if (itemHit == 3)
			ExitToShell();
			
		switch(itemHit)
		{
			case 56:
				curPDP = curPDP->prev;
				goto restart;
				break;
			case 57:
				curPDP = curPDP->next;
				goto restart;
				break;
		}
		
		GetPDValues(s_paramDialog);
	
		CheckPause();

#ifdef NO_FORE_DRAW
		s_SetGWorld(currPort,currDev);
#endif /*def NO_FORE_DRAW*/

	}
#endif /*!S_UNIX || XDialog*/

#if S_UNIX && XDialog
	else
#endif /*S_UNIX && XDialog*/

#if S_UNIX
	{	
		if (s_Config.foreground)
		{
			s_PD.curTopPDP = s_paramDialog;
			curPDP = s_paramDialog;
	
	restart_CUIPD:
	
			PDUnixShowPD(curPDP, panelNum);
			
			fgets(reply, 255, stdin);
			
			if (!isdigit(reply[0]))
			{
				if (PDUnixDistinguishAlpha(reply, &curPDP, &panelNum)) /*may exit*/
					return; /*continue*/
				else
					goto restart_CUIPD;
			}
		
			PDUnixHandleDigit(reply, curPDP, panelNum);
			
			goto restart_CUIPD;
		}	
		return;
	}
#endif /*S_UNIX*/
}


#if !S_UNIX || XDialog
short PDModalDialog(PDSet *pdp)
{
short itemHit;
short	iType;
Handle	iHandle;
Rect	iRect;
int		newChkValue;

	ModalDialog(nil,&itemHit);
	while((4<itemHit)&&(itemHit<56)) 
	{
		GetDialogItem(pdp->dialog,itemHit,&iType,&iHandle,&iRect);
		switch(iType)
		{
		case ctrlItem|chkCtrl: /*flagType*/
			newChkValue=!GetControlValue((ControlHandle)iHandle);
			SetControlValue((ControlHandle)iHandle,newChkValue);
			break;
		case ctrlItem|btnCtrl: /*doType*/
			HideWindow(GetDialogWindow(pdp->dialog));
			GetPDValues(s_PD.curTopPDP);
			(*pdp->paramList[(itemHit-ParamStart-1)/2].val.func)();
			SetPDValues(s_PD.curTopPDP);
			SelectWindow(GetDialogWindow(pdp->dialog));
			ShowWindow(GetDialogWindow(pdp->dialog));
			break;
		default:
			printf("Error!\n");
			Stop();
			break;
		}		
		ModalDialog(nil,&itemHit);
	}
	
	return itemHit;
}

#endif /*!S_UNIX || XDialog*/


#if S_UNIX
void PDUnixShowPD(PDSet *pdp, int panelNum)
{
int i;
char prevString[20], nextString[20];

	for(i = 0; i < pdp->paramNum; i++)
	{
		printf("%3d %-30s  ", panelNum*MaxPNum+i+1, pdp->paramList[i].comstr);
		PrintPDValues(pdp->paramList[i].type, pdp->paramList[i].p);
	}
	
	if (pdp->prev)
		strcpy(prevString, "p: prev, ");
	else
		strcpy(prevString, "");
	
	if (pdp->next)
		strcpy(nextString, "n: next, ");
	else
		strcpy(nextString, "");

	printf("%d - %d: item, %s%sc: continue, q: quit : ",
				panelNum*MaxPNum+1, panelNum*MaxPNum + pdp->paramNum,
				prevString, nextString);
}


int PDUnixDistinguishAlpha(char* reply, PDSet **pdpp, int *panelNumP)
{
	switch(reply[0])
	{
	case 'n':
	case 'N':
		if (pdpp[0]->next)
		{
			pdpp[0] = pdpp[0]->next;
			*panelNumP++;
		}
		else
			printf("No next panel!\n");
		break;
	case 'p':
	case 'P':
		if (pdpp[0]->prev)
		{
			pdpp[0] = pdpp[0]->prev;
			*panelNumP--;
		}
		else
			printf("No previous panel!\n");
		break;
	case 'c':
	case 'C':
	case '\n':
		return 1;
		break;
	case 'q':
	case 'Q':
		exit(0);
		break;
	default:
		printf("Cannot understand %s!\n", reply);
		break;
	}
	return 0;
}


void PDUnixHandleDigit(char *reply, PDSet *pdp, int panelNum)
{
int itemNum;
int choosedParam;

	itemNum = atoi(reply);
	
	choosedParam = itemNum - panelNum*MaxPNum - 1; /* should be modified to choose appropriate panel */
	
	if (! ( (choosedParam >=0) && (choosedParam < pdp->paramNum) ) )
	{
		printf("%d is out of range!\n", itemNum);
		return;
	}
	
	switch(pdp->paramList[choosedParam].type)
	{
	case flagType:
		*(int*)(pdp->paramList[choosedParam].p) = 1 - *(int*)(pdp->paramList[choosedParam].p);
		return;
		break;
	case doType:
		((void (*)(void))(pdp->paramList[choosedParam].p))();
		return;
		break;						
	default:
		break;
	}
	
	printf("%3d %-30s  ", panelNum*MaxPNum+choosedParam+1, pdp->paramList[choosedParam].comstr);
	PrintPDValues(pdp->paramList[choosedParam].type, pdp->paramList[choosedParam].p);
	printf("%3d %-30s  ", panelNum*MaxPNum+choosedParam+1, pdp->paramList[choosedParam].comstr);
	fgets(reply, 255, stdin);

	switch(pdp->paramList[choosedParam].type)
	{
	case intType : 
	case staticIntType:
		sscanf(reply,"%d",(int *)(pdp->paramList[choosedParam].p));
		break;
	case longType:
		sscanf(reply,"%ld",(long *)(pdp->paramList[choosedParam].p));
		break;
	case shortType:
		sscanf(reply,"%hd",(short *)(pdp->paramList[choosedParam].p));
		break;
	case doubleType : 
	case expType: /* f, e, g are same */
		sscanf(reply,"%lf",(double *)(pdp->paramList[choosedParam].p));
		break;
	case stringType:
		sscanf(reply,"%[^\n]",(char *)(pdp->paramList[choosedParam].p));
		break;						
	case staticStringType:
		break;						
	default:
		break;
	}
	return;
}

#endif /*S_UNIX*/


#if S_UNIX
void PrintPDValues(int type, Ptr p)
{
	switch(type)
	{
	case intType : 
	case staticIntType:
		printf("%d\n",*(int *)p);
		break;
	case longType:
		printf("%ld\n",*(long *)p);
		break;
	case shortType:
		printf("%d\n",*(short *)p);
		break;
	case doubleType : 
		printf("%f\n",*(double *)p);
		break;
	case expType: 
		printf("%e\n",*(double *)p);
		break;
	case stringType:
	case staticStringType:
		printf("%s\n",(char *)p);
		break;						
	case flagType:
		if (*(int*)p )
			printf("....x....\n");
		else
			printf("...._....\n");
		break;
	case doType:
		printf("....Do...\n");
		break;						
	default:;
	}
}
#endif /*S_UNIX*/



void SetPDValues(PDSet* s_paramDialog)
{
#if !S_UNIX || XDialog
PDSet* curPDP;

int i;
short iType;
Handle iHandle;
Rect iRect;

	curPDP = s_paramDialog;

	while (curPDP)
	{

		for(i=0;i<curPDP->paramNum;i++)
		{
			switch (curPDP->paramList[i].type)
			{
			case intType: 
				curPDP->paramList[i].val.intV = *(int*)curPDP->paramList[i].p;
				sprintf(curPDP->paramList[i].valstr,"%d",curPDP->paramList[i].val.intV);
				break;
			case longType: 
				curPDP->paramList[i].val.longV = *(long*)curPDP->paramList[i].p;
				sprintf(curPDP->paramList[i].valstr,"%ld",curPDP->paramList[i].val.longV);
				break;
			case shortType: 
				curPDP->paramList[i].val.shortV = *(short*)curPDP->paramList[i].p;
				sprintf(curPDP->paramList[i].valstr,"%hd",curPDP->paramList[i].val.shortV);
				break;
			case doubleType: 
				curPDP->paramList[i].val.doubleV = *(double*)curPDP->paramList[i].p;
				sprintf(curPDP->paramList[i].valstr,"%f",(double)curPDP->paramList[i].val.doubleV);
				break;
			case expType: 
				curPDP->paramList[i].val.doubleV = *(double*)curPDP->paramList[i].p;
				sprintf(curPDP->paramList[i].valstr,"%e",(double)curPDP->paramList[i].val.doubleV);
				break;
			case stringType: 
				curPDP->paramList[i].val.stringV = (char*)curPDP->paramList[i].p;
				sprintf(curPDP->paramList[i].valstr,curPDP->paramList[i].val.stringV);
				break;
			case staticIntType:
			case staticStringType: 
				break;
			case flagType:
				curPDP->paramList[i].val.intV = *(int*)curPDP->paramList[i].p;
				break;								
			default:;
			}
			
			switch (curPDP->paramList[i].type)
			{
				case intType:
				case longType:
				case shortType:
				case doubleType:
				case expType: 
				case stringType:
					C2PString(curPDP->paramList[i].valstr,curPDP->paramList[i].valpstr);
					GetDialogItem(curPDP->dialog,ParamStart+2*i+1,&iType,&iHandle,&iRect);
					SetDialogItemText(iHandle,curPDP->paramList[i].valpstr);
					break;
				case staticIntType:
				case staticStringType:
					break;
				case flagType:
					GetDialogItem(curPDP->dialog,ParamStart+2*i+1,&iType,&iHandle,&iRect);
					SetControlValue((ControlHandle)iHandle,curPDP->paramList[i].val.intV);
					break;
			}
		}
		
		curPDP = curPDP->next;
	}
#endif /*S_UNIX || XDialog*/
}


void GetPDValues(PDSet* s_paramDialog)
{
#if !S_UNIX || XDialog
PDSet* curPDP;

int i;
short iType;
Handle iHandle;
Rect iRect;
Str255 text;

	curPDP = s_paramDialog;

	while (curPDP)
	{

		for(i=0; i < curPDP->paramNum ;i++)
		{
			GetDialogItem(curPDP->dialog,ParamStart+2*i+1,&iType,&iHandle,&iRect);
			switch (curPDP->paramList[i].type)
			{
			case intType:
			case longType:
			case shortType:
			case doubleType: 
			case expType: 
			case stringType:
				GetDialogItemText(iHandle,text);
				if(strcmp((char*)text,(char*)curPDP->paramList[i].valpstr))
				{
					P2CString(text,curPDP->paramList[i].valstr);
					switch (curPDP->paramList[i].type)
					{
					case intType :
						sscanf(curPDP->paramList[i].valstr,"%d",&(curPDP->paramList[i].val.intV));
						*(int*)curPDP->paramList[i].p = curPDP->paramList[i].val.intV;
						break;
					case longType :
						sscanf(curPDP->paramList[i].valstr,"%ld",&(curPDP->paramList[i].val.longV));
						*(long*)curPDP->paramList[i].p = curPDP->paramList[i].val.longV;
						break;
					case shortType :
						sscanf(curPDP->paramList[i].valstr,"%hd",&(curPDP->paramList[i].val.shortV));
						*(short*)curPDP->paramList[i].p = curPDP->paramList[i].val.shortV;
						break;
					case doubleType :
					case expType: 
						sscanf(curPDP->paramList[i].valstr,"%lf",&(curPDP->paramList[i].val.doubleV));
						*(double*)curPDP->paramList[i].p = curPDP->paramList[i].val.doubleV;
						break;
					case stringType :
						strcpy(curPDP->paramList[i].val.stringV,curPDP->paramList[i].valstr);
						strcpy((char*)curPDP->paramList[i].p,curPDP->paramList[i].valstr);
						break;
					default:;
					}
				}
				break;
			case flagType:
				curPDP->paramList[i].val.intV=GetControlValue((ControlHandle)iHandle);
				*((int*)curPDP->paramList[i].p) = curPDP->paramList[i].val.intV;
				break;
			}
		}
		
		curPDP = curPDP->next;
	}
#endif /*!S_UNIX || XDialog*/
}


void DisplayParametersP(PDSet* s_paramDialog)
{
#if !S_UNIX
int i,j,k,hs=200,vs=20,rowN=13;
short iType;
Handle iHandle;
Rect iRect;
Str255 text;

	for(i=0;i<s_paramDialog->paramNum;i++)
	{
		j=i%rowN;
		k=2*(i/rowN);
		SetRect(&iRect,k*hs,j*vs+5,(k+1)*hs,(j+1)*vs+5);
		EraseRect(&iRect);
		MoveTo(k*hs,(j+1)*vs);
		DrawString(s_paramDialog->paramList[i].com);
		SetRect(&iRect,(k+1)*hs,j*vs+5,(k+2)*hs,(j+1)*vs+5);
		EraseRect(&iRect);
		MoveTo((k+1)*hs,(j+1)*vs);
		switch(s_paramDialog->paramList[i].type)
		{
			case intType: 
			case longType: 
			case shortType: 
			case doubleType:
			case expType: 
			case stringType:
				GetDialogItem(s_paramDialog->dialog,ParamStart+2*i+1,&iType,&iHandle,&iRect);
				GetDialogItemText(iHandle,text);
				DrawString(text);
				break;
			case flagType:
				if (s_paramDialog->paramList[i].val.intV)
				{
					DrawChar('1');
				}
				else
				{
					DrawChar('0');
				}
				break;
			default:;
		}
	}
	CheckPause();
#endif /*!S_UNIX*/
}


/********** Save Parameters **********/

void SavePDParameters(void)
{
FILE *PDPFile;
PDSet *curPDP;
int i;
#if S_UNIX
char fileName[256];
#endif

#if !S_UNIX
	PDPFile = DialogFOpen(s_PD.paramFileName, "w");
#else
	sprintf(fileName, "%s%s", s_Config.dataDirNameString, s_PD.paramFileName);
	PDPFile = fopen(fileName, "w");
#endif

	if (!PDPFile)
	{
		s_printf("Error while writing parameters file, may be canceled\n");
		return;
	}
	
	curPDP = s_PD.curTopPDP;

	while (curPDP)
	{
		for (i = 0; i < curPDP->paramNum; i++)
		{
			FprintfPDParamList(PDPFile, curPDP->paramList[i]);
		}
		
		curPDP = curPDP->next;
	}
	
	fclose(PDPFile);	
}


void FprintfPDParamList(FILE *fp, PDParameterList paramList)
{
char writeString[512];

	PDParamListString(writeString, paramList);
	
	fprintf(fp, "%s", writeString);
}


void PDParamListString(char *writeString, PDParameterList paramList)
{
Ptr p;

	p = paramList.p;

	sprintf(writeString, "\"%s\"\t", paramList.comstr);
	
	switch( paramList.type )
	{
	case intType:
		sprintf(writeString, "\"%s\"\tintType\t%d\n", paramList.comstr, *(int*)p);
		break;
	case staticIntType:
		sprintf(writeString, "\"%s\"\tstaticIntType\t%d\n", paramList.comstr, *(int*)p);
		break;
	case longType:
		sprintf(writeString, "\"%s\"\tlongType\t%ld\n", paramList.comstr, *(long*)p);
		break;
	case shortType:
		sprintf(writeString, "\"%s\"\tshortType\t%d\n", paramList.comstr, *(short*)p);
		break;
	case doubleType:
		sprintf(writeString, "\"%s\"\tdoubleType\t%f\n", paramList.comstr, *(double*)p);
		break;
	case expType: 
		sprintf(writeString, "\"%s\"\texpType\t%e\n", paramList.comstr, *(double*)p);
		break;
	case stringType:
		sprintf(writeString, "\"%s\"\tstringType\t%s\n", paramList.comstr, (char*)p);
		break;
	case staticStringType:
		sprintf(writeString, "\"%s\"\tstaticStringType\t%s\n", paramList.comstr, (char*)p);
		break;
	case flagType:
		sprintf(writeString, "\"%s\"\tflagType\t%d\n", paramList.comstr, *(int*)p);
		break;
	case doType:
		sprintf(writeString, "\"%s\"\tdoType\t%p\n", paramList.comstr, *(void **)p);
		break;
	default:
		s_printf("Error in PDParamListString: Type %d is not defined\n", paramList.type);
		break;
	}
}


void LoadPDParameters(void)
{
	LoadFileNamePDParameters("");
}


void LoadFileNamePDParameters(char *fileName)
{
FILE *PDPFile;
PDSet *curPDP;
int i;

	if (!fileName[0])
	{
		fileName = calloc(256, sizeof(char));
#if !S_UNIX
	PDPFile = DialogFOpen("SCLPDParams", "r");
#else
	sprintf(fileName, "%sSCLPDParams", s_Config.dataDirNameString);
	PDPFile = fopen(fileName, "r");
#endif
	}
	else
		PDPFile = fopen(fileName, "r");

	if (!PDPFile)
	{
		s_printf("Error while opening parameters file\n");
		return;
	}
	
	curPDP = s_PD.curTopPDP;

	while (curPDP)
	{
		for (i = 0; i < curPDP->paramNum; i++)
		{
			if ( FscanfPDParamList(PDPFile, (curPDP->paramList)[i]) )
			{
				fclose(PDPFile);
				return;
			}
		}		
		curPDP = curPDP->next;
	}	
	fclose(PDPFile);	
}


int FscanfPDParamList(FILE *fp, PDParameterList paramList)
{
Ptr p;
char oneLine[512];
char comString[256];
char typeString[32];
char valString[256];
int scanedNum;
int paramType;
char PDString[512];


	p = paramList.p;
	
	fgets(oneLine, 512, fp);
	
	scanedNum = sscanf(oneLine, "\"%[^\"]\"\t%s\t%[^\n]", comString, typeString, valString);
		
	if ( scanedNum < 2 )
	{
		s_printf("Error in FscanfPDParamList:\nthe line\n%s\nis wrong format\n", oneLine);
		return -1; /* error*/
	}
	
	paramType = PDStringToType(typeString);
	
	if ((strcmp(comString, paramList.comstr)) || (paramType != paramList.type))
	{
		s_printf("Error in FscanfPDParamList:\nData type incompatible\n");
		s_printf("File: %s\n", oneLine);
		PDParamListString(PDString,  paramList);
		s_printf("Dialog: %s\n", PDString);
		return -1; /* error*/
	}

	
	switch( paramType )
	{
	case intType:
		*(int*)p = atoi(valString);
		break;
	case staticIntType:
		/* do not change */
		break;
	case longType:
		*(long*)p = atol(valString);
		break;
	case shortType:
		*(short*)p = atoi(valString);
		break;
	case doubleType:
	case expType:
		*(double*)p = atof(valString);
		break;
	case stringType:
		strcpy((char*)p, valString);
		break;
	case staticStringType:
		/* do not change */
		break;
	case flagType:
		*(int*)p = atoi(valString);
		break;
	case doType:
		/* do not change */
		break;
	default:
		s_printf("Error in FscanfPDParamList: Type %d is not defined\n", paramList.type);
		break;
	}
	
	return 0; /* no error */
}


int PDStringToType(char *typeName)
{
int i = 0;

	while ( s_PDTypePairTable[i].typeName )
	{
		if ( !strcmp(s_PDTypePairTable[i].typeName, typeName) )
			return s_PDTypePairTable[i].typeNum;
		i++;
	}
	return -1; /*error*/
}


/**************************************************
	void SetParametersDialogInitFile(char *fileName)
	Set to load initial parameters from fileName file
**************************************************/

void SetParametersDialogInitFile(char *fileName)
{
	strcpy(s_PD.paramFileName, fileName);
	s_PD.loadParamFlag = 1;
}


/**************************************************
	void PDInitLoadParams(void)
	Load initial parameters from file
**************************************************/

void PDInitLoadParams(void)
{
	GetPDValues(s_PD.curTopPDP);
	LoadFileNamePDParameters(s_PD.paramFileName);
	SetPDValues(s_PD.curTopPDP);
	s_PD.loadParamFlag = 0;
}

#undef dp /* dp(...) was debug code */

#include <s_define.c>

#endif /*pragma once*/
