/*
 *  Plot.c 
 *  Version 2.0.2 / 011212
 *  by Satoshi Takahashi, Yuriko Hayashi
 */

#ifndef PLOT_C /*pragma once*/
#define PLOT_C

#include <s_Config.h>

#include <string.h>
#include <math.h>
#include <stdio.h>

#include <Plot.h>
#include <StartSCL.h>
#include <Save.h>
#include <s_Print.h>
#include <s_RedrawFunc.h>
#include <s_define.c>

#if S_UNIX /* as s_Toolbox.h is not in parts-main */
#include <s_Toolbox.h>
#endif

#include <VarBody.h>
#include <Plot-v.c>

double s_p_scale = 1.0;

long	 s_n=0, s_on=0
		,s_bn=0,	s_bx=0, s_by=0, s_bz=0, s_bu=0 ,s_br=0, s_bs=0
		,s_color_flag = 1
		;

double	s_ox=0.0, s_oy=0.0, s_oz=0.0, s_ou=0.0, s_or=0.0, s_os=0.0,
			s_wn=1.0,	s_wx=100.0, s_wy=100.0, s_wz=100.0, s_wu=100.0, s_wr=100.0, s_ws=100.0,
							s_xx=0.0, s_yy=0.0, s_zz=0.0, s_uu=0.0, s_rr=0.0, s_sss=0.0;


void	SetPlot4O(int vn, double vx, double vy, double vz, double vu)
{ s_on=vn;	s_ox=vx; s_oy=vy; s_oz=vz; s_ou=vu;}

void	SetPlot4W(double vn, double vx, double vy, double vz, double vu)
{ s_wn=vn;	s_wx=vx; s_wy=vy; s_wz=vz; s_wu=vu;}

void	SetPlot4B(int vn, int vx, int vy, int vz, int vu)
{ s_bn=vn;	s_bx=vx; s_by=vy; s_bz=vz; s_bu=vu;}

void	SetPlot4I(double x, double y, double z, double u)
{	s_xx=x; s_yy=y; s_zz=z; s_uu=u;}

void	SetPlot6O(int vn, double vx, double vy, double vz, double vu, double vr, double vs)
{ s_on=vn;	s_ox=vx; s_oy=vy; s_oz=vz; s_ou=vu; s_or=vr; s_os=vs;}

void	SetPlot6W(double vn, double vx, double vy, double vz, double vu, double vr, double vs)
{ s_wn=vn;	s_wx=vx; s_wy=vy; s_wz=vz; s_wu=vu; s_wr=vr; s_ws=vs;}

void	SetPlot6B(int vn, int vx, int vy, int vz, int vu, int vr, int vs)
{ s_bn=vn;	s_bx=vx; s_by=vy; s_bz=vz; s_bu=vu; s_br=vr; s_bs=vs;}

void	SetPlot6I(double x, double y, double z, double u, double r, double s)
{	s_xx=x; s_yy=y; s_zz=z; s_uu=u; s_rr=r; s_sss=s;}

void	SetPlot2D2I(double x, double y)
{	
	s_MoveTo(s_p_scale*(s_wx*(x-s_ox)+s_bx),s_p_scale*(s_wy*(s_oy-y)-s_by+DrawingHeight()));	
}

void	Plot1(double x)
{
							
	if (s_color_flag)
	{
		ForeColor(s_p.color1);
	}
	else
	{
		PenSize(s_p.pen1,s_p.pen1);
	}
	MoveTo(s_wn*s_n+s_bn,s_wx*(s_ox-s_xx)-s_bx+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wx*(s_ox-x)-s_bx+DrawingHeight());
	
	s_xx=x;
	s_n++;
	if (s_wn*(s_n+1)+s_bn > DrawingWidth())
		PlotNewPage();
	ForeColor(blackColor);
}

void	Plot2(double x, double y)
{
							
	if (s_color_flag)
	{
		ForeColor(s_p.color1);
	}
	else
	{
		PenSize(s_p.pen1,s_p.pen1);
	}
	MoveTo(s_wn*s_n+s_bn,s_wx*(s_ox-s_xx)-s_bx+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wx*(s_ox-x)-s_bx+DrawingHeight());
	
	if (s_color_flag)
	{
		ForeColor(s_p.color2);
	}
	else
	{
		PenSize(s_p.pen2,s_p.pen2);
	}
	MoveTo(s_wn*s_n+s_bn,s_wy*(s_oy-s_yy)-s_by+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wy*(s_oy-y)-s_by+DrawingHeight());

	s_xx=x;
	s_yy=y;
	s_n++;
	if (s_wn*(s_n+1)+s_bn > DrawingWidth())
		PlotNewPage();
	ForeColor(blackColor);
}

void	Plot3(double x, double y,double z)
{
							
	if (s_color_flag)
	{
		ForeColor(s_p.color1);
	}
	else
	{
		PenSize(s_p.pen1,s_p.pen1);
	}
	MoveTo(s_wn*s_n+s_bn,s_wx*(s_ox-s_xx)-s_bx+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wx*(s_ox-x)-s_bx+DrawingHeight());

	if (s_color_flag)
	{
		ForeColor(s_p.color2);
	}
	else
	{
		PenSize(s_p.pen2,s_p.pen2);
	}
	MoveTo(s_wn*s_n+s_bn,s_wy*(s_oy-s_yy)-s_by+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wy*(s_oy-y)-s_by+DrawingHeight());
	
	if (s_color_flag)
	{
		ForeColor(s_p.color3);
	}
	else
	{
		PenSize(s_p.pen3,s_p.pen3);
	}
	MoveTo(s_wn*s_n+s_bn,s_wz*(s_oz-s_zz)-s_bz+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wz*(s_oz-z)-s_bz+DrawingHeight());
	
	s_xx=x;
	s_yy=y;
	s_zz=z;
	s_n++;
	if (s_wn*(s_n+1)+s_bn > DrawingWidth())
	{
		PlotNewPage();
	}
	ForeColor(blackColor);
}

void	Plot4(double x, double y, double z, double u)
{
							
	if (s_color_flag)
	{
		ForeColor(s_p.color1);
	}
	else
	{
		PenSize(s_p.pen1,s_p.pen1);
	}
	MoveTo(s_wn*s_n+s_bn,s_wx*(s_ox-s_xx)-s_bx+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wx*(s_ox-x)-s_bx+DrawingHeight());
	
	if (s_color_flag)
	{
		ForeColor(s_p.color2);
	}
	else
	{
		PenSize(s_p.pen2,s_p.pen2);
	}
	MoveTo(s_wn*s_n+s_bn,s_wy*(s_oy-s_yy)-s_by+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wy*(s_oy-y)-s_by+DrawingHeight());
	
	if (s_color_flag)
	{
		ForeColor(s_p.color3);
	}
	else
	{
		PenSize(s_p.pen3,s_p.pen3);
	}
	MoveTo(s_wn*s_n+s_bn,s_wz*(s_oz-s_zz)-s_bz+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wz*(s_oz-z)-s_bz+DrawingHeight());
	
	if (s_color_flag)
	{
		ForeColor(s_p.color4);
	}
	else
	{
		PenSize(s_p.pen4,s_p.pen4);
	}
	MoveTo(s_wn*s_n+s_bn,s_wu*(s_ou-s_uu)-s_bu+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wu*(s_ou-u)-s_bu+DrawingHeight());
	
	s_xx=x;
	s_yy=y;
	s_zz=z;
	s_uu=u;
	s_n++;
	if (s_wn*(s_n+1)+s_bn > DrawingWidth())
		PlotNewPage();
	ForeColor(blackColor);
}
void	Plot6(double x, double y, double z, double u, double r, double s)
{
							
	if (s_color_flag)
	{
		ForeColor(s_p.color1);
	}
	else
	{
		PenSize(s_p.pen1,s_p.pen1);
	}
	MoveTo(s_wn*s_n+s_bn,s_wx*(s_ox-s_xx)-s_bx+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wx*(s_ox-x)-s_bx+DrawingHeight());
	
	if (s_color_flag)
	{
		ForeColor(s_p.color2);
	}
	else
	{
		PenSize(s_p.pen2,s_p.pen2);
	}
	MoveTo(s_wn*s_n+s_bn,s_wy*(s_oy-s_yy)-s_by+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wy*(s_oy-y)-s_by+DrawingHeight());
	
	if (s_color_flag)
	{
		ForeColor(s_p.color3);
	}
	else
	{
		PenSize(s_p.pen3,s_p.pen3);
	}
	MoveTo(s_wn*s_n+s_bn,s_wz*(s_oz-s_zz)-s_bz+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wz*(s_oz-z)-s_bz+DrawingHeight());
	
	if (s_color_flag)
	{
		ForeColor(s_p.color4);
	}
	else
	{
		PenSize(s_p.pen4,s_p.pen4);
	}
	MoveTo(s_wn*s_n+s_bn,s_wu*(s_ou-s_uu)-s_bu+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wu*(s_ou-u)-s_bu+DrawingHeight());
	
	if (s_color_flag)
	{
		ForeColor(s_p.color5);
	}
	else
	{
		PenSize(s_p.pen5,s_p.pen5);
	}
	MoveTo(s_wn*s_n+s_bn,s_wr*(s_or-s_rr)-s_br+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_wr*(s_or-r)-s_br+DrawingHeight());
	
	if (s_color_flag)
	{
		ForeColor(s_p.color6);
	}
	else
	{
		PenSize(s_p.pen6,s_p.pen6);
	}
	MoveTo(s_wn*s_n+s_bn,s_ws*(s_os-s_sss)-s_bs+DrawingHeight());
	LineTo(s_wn*(s_n+1)+s_bn,s_ws*(s_os-s)-s_bs+DrawingHeight());
	
	s_xx=x;
	s_yy=y;
	s_zz=z;
	s_uu=u;
	s_rr=r;
	s_sss=s;
	s_n++;
	if (s_wn*(s_n+1)+s_bn > DrawingWidth())
		PlotNewPage();
	ForeColor(blackColor);
}

void PlotNewPage(void)
{
		s_n=0;
#ifdef S_SATOSHI2
		if (s_p.print) {EndPrinting();}
		if (s_p.bitMapPrint) {EndBitMapPrinting();}
		if (s_p.save) {EndBitMapSavingAuto();}
#endif
	if (s_p.newPageStop)
		Stop();
	EraseDrawing();
#ifdef S_SATOSHI2
		if (s_p.print) {BeginPrinting();}
#endif
	if (s_p.newPageFunc)
	{
		ForeColor(blackColor);
		PenSize(1,1);
		(*s_p.newPageFunc)();
	}
}
	


void	Plot2D2(double x, double y)
{
							
	Plot2DLineTo(x,y);	
	//ForeColor(blackColor);
}


void	Plot2D2P(double x, double y)
{
double xx,yy;
	
	xx = s_wx*(x-s_ox)+s_bx;
	yy = s_wy*(s_oy-y)-s_by+DrawingHeight();
	if (PlotPointInRegion(xx, yy))
	{
		MoveTo(xx,yy);	
		LineTo(xx,yy);
	}
	//ForeColor(blackColor);
}

int PlotPointInRegion(double x, double y)
{
	if ( (s_p.regionMinX <= x) && (x <= s_p.regionMaxX)
			&&(s_p.regionMinY <= y) && (y <= s_p.regionMaxY) )
	{
		s_p.inRegionFlag = 1;
		return 1;
	}
	else
	{
		s_p.inRegionFlag = 0;
		return 0;
	}
}


void SetCoordinateDigit(int digit)
{
	s_p.frameXMinDigit = digit;
	s_p.frameXMaxDigit = digit;
	s_p.frameYMinDigit = digit;
	s_p.frameYMaxDigit = digit;
}

void SetFrame2DXMinDigit(int digit)
{
	s_p.frameXMinDigit = digit;
}

void SetFrame2DXMaxDigit(int digit)
{
	s_p.frameXMaxDigit = digit;
}

void SetFrame2DYMinDigit(int digit)
{
	s_p.frameYMinDigit = digit;
}

void SetFrame2DYMaxDigit(int digit)
{
	s_p.frameYMaxDigit = digit;
}


void	PlotFrame1D(double n1, double n2, double x1, double x2)
{
	MoveTo(s_wn*n1+s_bn,s_wx*(s_ox-x1)-s_bx+DrawingHeight());
	LineTo(s_wn*n2+s_bn,s_wx*(s_ox-x1)-s_bx+DrawingHeight());
	LineTo(s_wn*n2+s_bn,s_wx*(s_ox-x2)-s_bx+DrawingHeight());
	LineTo(s_wn*n1+s_bn,s_wx*(s_ox-x2)-s_bx+DrawingHeight());
	LineTo(s_wn*n1+s_bn,s_wx*(s_ox-x1)-s_bx+DrawingHeight());
}

#if !S_UNIX
extern pascal short TextWidth(const void *textBuf, short firstByte, short byteCount);
#endif

void	PlotFrame2D(double x1, double x2, double y1, double y2)
{
	PlotFrame2DSeparate(x1, x2, y1, y2, x1, x2, y1, y2);
}

void	PlotFrame2DSeparate(double x1, double x2, double y1, double y2,
							double x3, double x4, double y3, double y4)
{
char scale_num[30];
int aLWidth = 0;

	Plot2DMoveTo(x1,y1);
	Plot2DLineTo(x2,y1);
	Plot2DLineTo(x2,y2);
	Plot2DLineTo(x1,y2);
	Plot2DLineTo(x1,y1);
#define _TWO 0
	//x1 = x3;
	//x2 = x4;
	//y1 = y3;
	//y2 = y4;
	if (s_p.showXMin)
	{
		sprintf(scale_num,"%.*f",s_p.frameXMinDigit,x3);	
		aLWidth = TextWidth(scale_num,0,strlen(scale_num));
		Plot2DMoveTo(x1,y1);
		Move(((-aLWidth/2.0)+s_p.xNumPositionX)/s_d_scale,
				s_p.xNumPositionY/s_d_scale);
		DrawText(scale_num,0,strlen(scale_num));
	}
	if (s_p.showXMax)
	{
		sprintf(scale_num,"%.*f",s_p.frameXMaxDigit,x4);
		aLWidth = TextWidth(scale_num,0,strlen(scale_num));
		Plot2DMoveTo(x2,y1);
		Move(((-aLWidth/2.0)+s_p.xNumPositionX)/s_d_scale,
				s_p.xNumPositionY/s_d_scale);
		DrawText(scale_num,0,strlen(scale_num));
	}
	if (s_p.showYMin)
	{
		sprintf(scale_num,"%.*f",s_p.frameYMinDigit,y3);
		aLWidth = TextWidth(scale_num,0,strlen(scale_num));
		Plot2DMoveTo(x1,y1);
		Move((-aLWidth + s_p.yNumPositionX + _TWO)/s_d_scale,
				s_p.yNumPositionY/s_d_scale);
		DrawText(scale_num,0,strlen(scale_num));
	}
	if (s_p.showYMax)
	{
		sprintf(scale_num,"%.*f",s_p.frameYMaxDigit,y4);
		aLWidth = TextWidth(scale_num,0,strlen(scale_num));
		Plot2DMoveTo(x1,y2);
		Move((-aLWidth + s_p.yNumPositionX + _TWO)/s_d_scale,
				s_p.yNumPositionY/s_d_scale);
		DrawText(scale_num,0,strlen(scale_num));
	}
}


void SetColorPlotOn()
{

	s_color_flag = 1;
}

void SetColorPlotOff()
{

	s_color_flag = 0;
}

void ResetPen()
{
	if (s_color_flag)
	{
		ForeColor(s_p.color1);
	}
	else
	{
		PenSize(s_p.pen1,s_p.pen1);
	}
}


void PlotPaintCircle(double w)
{
Rect	r;
Point	p;

	if (s_p.inRegionFlag)
	{
		GetPen(&p);
		SetRect(&r, (p.h - w)/s_d_scale + 0.5, (p.v - w)/s_d_scale + 0.5,
					(p.h + w)/s_d_scale + 0.5,(p.v + w)/s_d_scale + 0.5);
		PaintOval(&r);
	}
}


void PlotCircle(double w)
{
Rect	r;
Point	p;

	if (s_p.inRegionFlag)
	{
		GetPen(&p);
		SetRect(&r, (p.h - w)/s_d_scale + 0.5, (p.v - w)/s_d_scale + 0.5,
					(p.h + w)/s_d_scale + 0.5,(p.v + w)/s_d_scale + 0.5);
		FrameOval(&r);
	}
}


void PlotPaintRect(double w)
{
Rect	r;
Point	p;

	if (s_p.inRegionFlag)
	{
		GetPen(&p);
		SetRect(&r, (p.h - w)/s_d_scale + 0.5, (p.v - w)/s_d_scale + 0.5,
					(p.h + w)/s_d_scale + 0.5,(p.v + w)/s_d_scale + 0.5);
		PaintRect(&r);
	}
}


void PlotRect(double w)
{
Rect	r;
Point	p;

	if (s_p.inRegionFlag)
	{
		GetPen(&p);
		SetRect(&r, (p.h - w)/s_d_scale + 0.5, (p.v - w)/s_d_scale + 0.5,
					(p.h + w)/s_d_scale + 0.5,(p.v + w)/s_d_scale + 0.5);
		FrameRect(&r);
	}
}


void PlotCross(double w)
{
Point	p;

	if (s_p.inRegionFlag)
	{
		GetPen(&p);
		s_MoveTo((p.h - w)/s_d_scale + 0.5, p.v/s_d_scale + 0.5);
		LineTo((p.h + w)/s_d_scale + 0.5,p.v/s_d_scale + 0.5);
		s_MoveTo(p.h/s_d_scale + 0.5, (p.v - w)/s_d_scale + 0.5);
		LineTo(p.h/s_d_scale + 0.5,(p.v + w)/s_d_scale + 0.5);
		s_MoveTo(p.h, p.v);
	}
}


void PlotPaintTriangle(double w)
{
Point	p;
PolyHandle poly;

	if (s_p.inRegionFlag)
	{
		GetPen(&p);
		poly = s_OpenPoly();
		s_MoveTo(p.h/s_d_scale + 0.5, (p.v - w)/s_d_scale + 0.5);
		LineTo((p.h - w)/s_d_scale + 0.5,(p.v + w)/s_d_scale + 0.5);
		LineTo((p.h + w)/s_d_scale + 0.5,(p.v + w)/s_d_scale + 0.5);
		LineTo(p.h/s_d_scale + 0.5, (p.v - w)/s_d_scale + 0.5);
		s_ClosePoly();
		PaintPoly(poly);
		KillPoly(poly);
		s_MoveTo(p.h, p.v);
	}
}


void PlotTriangle(double w)
{
Point	p;

	if (s_p.inRegionFlag)
	{
		GetPen(&p);
		s_MoveTo(p.h/s_d_scale + 0.5, (p.v - w)/s_d_scale + 0.5);
		LineTo((p.h - w)/s_d_scale + 0.5,(p.v + w)/s_d_scale + 0.5);
		LineTo((p.h + w)/s_d_scale + 0.5,(p.v + w)/s_d_scale + 0.5);
		LineTo(p.h/s_d_scale + 0.5, (p.v - w)/s_d_scale + 0.5);
		s_MoveTo(p.h, p.v);
	}
}


void SetPlotNewPageFunc(voidvoidFunc func)
{
	s_p.newPageFunc = func;
}

#if !S_UNIX /******************** !!!! UNIX ********************/

#include <s_undef.c>

void EnlargePlot2D(void)
{
EventRecord s_p_event;
double x1,y1,x2,y2;
Rect r;
int h1,v1;

	while(!(Pause(),GetNextEvent(mDownMask,&s_p_event)));
	GlobalToLocal(&s_p_event.where);
	h1 = s_p_event.where.h;
	v1 = s_p_event.where.v;
	x1 = (s_p_event.where.h-s_bx)/s_wx+s_ox;
	y1 = (DrawingHeight()-s_p_event.where.v-s_by)/s_wy+s_oy;

	PenMode(srcXor);
	while(!(Pause(),GetNextEvent(mUpMask,&s_p_event)))
	{
		GlobalToLocal(&s_p_event.where);
		if(s_p_event.modifiers&shiftKey)
		{
			s_p_event.where.v=v1+((double)s_p_event.where.h-h1)*DrawingHeight()/DrawingWidth();
		}
			SetRect(&r,	min(h1,s_p_event.where.h),min(v1,s_p_event.where.v),
									max(h1,s_p_event.where.h),max(v1,s_p_event.where.v));
		FrameRect(&r);
		WaitTick(1);
		FrameRect(&r);
		WaitTick(1);
	}
	PenMode(srcCopy);

	GlobalToLocal(&s_p_event.where);
	if(s_p_event.modifiers&shiftKey)
	{
		s_p_event.where.v=v1+((double)s_p_event.where.h-h1)*DrawingHeight()/DrawingWidth();
	}
	x2 = (s_p_event.where.h-s_bx)/s_wx+s_ox;
	y2 = (DrawingHeight()-s_p_event.where.v-s_by)/s_wy+s_oy;
	s_ox = (x1+x2)/2.0;
	s_oy = (y1+y2)/2.0;
	s_wx = DrawingWidth()/fabs(x2-x1);
	s_wy = DrawingHeight()/fabs(y2-y1);
	s_bx = DrawingWidth()/2;
	s_by = DrawingHeight()/2;
	EraseDrawing();
}

#include <s_define.c>

#endif /*!S_UNIX*/ /******************** UNIX ********************/


void ShrinkPlot2D(double cw)
{
	s_wx/=cw;
	s_wy/=cw;
	EraseDrawing();
}

void ShrinkPlot2DHalf(void)
{
	ShrinkPlot2D(2);
}


void Plot2DMoveTo(double x,double y)
{
double xx, yy;

	xx = s_p_scale*(s_wx*(x-s_ox)+s_bx);
	yy = s_p_scale*(s_wy*(s_oy-y)-s_by+DrawingHeight());
	if ( PlotPointInRegion(xx, yy) )
		MoveTo(xx, yy);	
}

void Plot2DLineTo(double x,double y)
{
double xx, yy;

	xx = s_p_scale*(s_wx*(x-s_ox)+s_bx);
	yy = s_p_scale*(s_wy*(s_oy-y)-s_by+DrawingHeight());
	if ( PlotPointInRegion(xx, yy) )
	{
//s_printf("%lf, %lf\n", xx, yy);
//LineTo(10, 10);
		LineTo((short)xx, (short)yy);
	}
}

void SetPlotPenSize4(int pen1,int pen2,int pen3,int pen4)
{
	s_p.pen1 = pen1;
	s_p.pen2 = pen2;
	s_p.pen3 = pen3;
	s_p.pen4 = pen4;
}

int Plot2DTransX(double x)
{
	return s_p_scale*(s_wx*(x-s_ox)+s_bx);
}

int Plot2DTransY(double y)
{
	return s_p_scale*(s_wy*(s_oy-y)-s_by+DrawingHeight());
}


double Plot2DReverseX(short px)
{
	return (px/s_p_scale - s_bx)/s_wx + s_ox;
}

double Plot2DReverseY(short py)
{
	return s_oy - (py/s_p_scale + s_by - DrawingHeight())/s_wy;
}


#ifdef S_SATOSHI2

void BeginPlotPrinting(void)
{
	BeginPrinting();
	s_p.print = 1;
}

void EndPlotPrinting(void)
{	
	EndPrinting();
	s_p.print = 0;
}

void BeginPlotBitMapPrinting(void)
{
	BeginBitMapPrinting();
	s_p.bitMapPrint = 1;
}

void EndPlotBitMapPrinting(void)
{	
	EndBitMapPrinting();
	s_p.bitMapPrint = 0;
}

void BeginPlotSaving(void)
{
	BeginBitMapSaving();
	s_p.save = 1;
}

void EndPlotSaving(void)
{	
	EndBitMapSavingAuto();
	s_p.save = 0;
}

void BeginPlotBitMapSaving(void)
{
	BeginPlotSaving();
}

void EndPlotBitMapSaving(void)
{	
	EndPlotSaving();
}

#endif

void SetPlotNewPageStopOn()
{
	s_p.newPageStop = 1;
}

void SetPlotNewPageStopOff()
{
	s_p.newPageStop = 0;
}

#endif /*pragma once*/

