/*
 *  SCL.h
 *  by Satoshi Takahashi
 */

#ifndef SCL_H /*pragma once*/
#define SCL_H
#ifdef __cplusplus
extern "C"{
#endif

#ifndef SCLLocal /*SCLLocal means SCL library is at user path*/
#include <s_Config.h>

#define SCL_VERSION_A 2
#define SCL_VERSION_B 1
#define SCL_VERSION_C 0

#define S_SATOSHI2


#include <math.h>

#if S_UNIX /* as s_Toolbox.h is not in parts-main */
#include <s_Toolbox.h>
#include <s_UNIX.h>
#if OLD_C
#include <OldC.h>
#endif /*OLD_C*/
#endif /*S_UNIX*/

#include <DelayedSetParams.h>
#include <DialogFOpen.h>

#if !S_UNIX
#include <DragAndDrop.h>
/* #include <DrawPictFile.h> */
#endif

#include <EPS.h>

#if !S_UNIX
/* #include <Formula.h> */
/* #include <Graph.h> */
#endif

#include <HugeArray.h>
/* #include <LinearSolve.h> */
/* #include <Newton.h> */
#include <ParametersDialog.h>
#include <PDProcs.h>
#include <Plot.h>
#include <s_Print.h>
/* #include <RungeKutta.h> */
#include <Save.h>
#include <StartSCL.h>
#include <s_Drawing.h>
#include <s_Math.h>
#include <s_Common.h>
/* #include <s_Profile.h> */
#include <s_RedrawFunc.h>
#include <s_String.h>
/* #include <s_UNIX.h> */

#if S_UNIX && UNIX_SCLC_INCLUDE
#include <SCL.c>
#endif

#include <s_define.c>

#else /*ndef SCLLocal*/

#include <math.h>

#include "DelayedSetParams.h"
#include "DialogFOpen.h"
#include "DragAndDrop.h"
#include "HugeArray.h"
#include "ParametersDialog.h"
#include "PDProcs.h"
#include "Plot.h"
#include "s_Print.h"
#include "Save.h"
#include "StartSCL.h"
#include "s_Drawing.h"
#include "s_Math.h"
#include "s_Common.h"
#include "s_RedrawFunc.h"
#include "s_String.h"
#include "s_define.c"

#endif
#ifdef __cplusplus
}
#endif
#endif /*pragma once*/

