/*
 *  Save.h
 *  Version 1.5 / 971128
 *  by Satoshi Takahashi & Akiya Iwasaki
 */


#ifndef SAVE_H /*pragma once*/
#define SAVE_H

#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif

#define S_SAVE

#include <stdio.h>

#ifndef SCLLocal
#include <s_Common.h>

#include <VarHeader.h>
#include <Save-v.c>
#else
#include "s_Common.h"

#include "VarHeader.h"
#include "Save-v.c"
#endif

/***** Saving Graphics *****/

void BeginSaving(void);

#if !S_UNIX
void SavePict(PicHandle s_pict);
#else
#define SavePict(a)
#endif

void EndSaving(void);

#define BeginDrawingSaving BeginSaving

#define EndDrawingSaving EndSaving

#if !S_UNIX
void SetDrawingCreator(OSType c);
#else
#define SetDrawingCreator(a)
#endif

void BeginBitMapSaving();
void EndBitMapSaving();
void EndBitMapSavingAuto();

#if !S_UNIX
void SetBitMapCreator(OSType c);
#else
#define SetBitMapCreator(a)
#endif

void EndBitMapSavingColor(void);
void EndBitMapSavingMono(void);

/***** Saving Text *****/


#if 0 /*in StartSCL.h*/
extern int s_textSaveFlag;
extern long	(*SaveTextP)(char *s);
#endif

short	BeginTextSaving(void);

void	EndTextSaving(void);

long	SaveText(char *s);

#if !S_UNIX
void SetTextCreator(OSType c);
#else
#define SetTextCreator(a)
#endif

#if !S_UNIX /******************** !!!! UNIX ********************/



/***** Reading Text *****/

short	BeginTextReading(void);
void	EndTextReading(void);
long	ReadText(char *s);

#endif /*!S_UNIX*/ /******************** UNIX ********************/


/***** Capitalize *****/

#define beginsaving BeginSaving
#define endsaving EndSaving


/***** Miscellaneus *****/

#endif /*pragma once*/
