/*
 *  s_AppleEvent.c
 *  Version 1.6 / 980609
 *  by Satoshi Takahashi
 */
 
#ifndef S_APPLEEVENT_C /*pragma once*/
#define S_APPLEEVENT_C

#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif
#if S_CARBON
#include <Carbon/Carbon.h>
#endif

#include <stdio.h>

#ifndef SCLLocal
#include <StartSCL.h>
#include <DragAndDrop.h>
#include <s_AppleEvent.h>
#else
#include "StartSCL.h"
#include "DragAndDrop.h"
#include "s_AppleEvent.h"
#endif

#ifdef THINK_C
#if THINK_C <= 6
#define AEEventHandlerUPP EventHandlerProcPtr
#define NewAEEventHandlerProc(a) a
#endif
#endif

void InitAppleEvent(void)
{
OSErr err;
AEEventHandlerUPP procOAPP,procQUIT,procODOC,procPDOC;

#if S_CARBON
	procODOC = NewAEEventHandlerUPP((AEEventHandlerProcPtr)SCLOpenDoc);
	procOAPP = NewAEEventHandlerUPP((AEEventHandlerProcPtr)SCLOpenApp);
	procPDOC = NewAEEventHandlerUPP((AEEventHandlerProcPtr)SCLPrintDoc);
	procQUIT = NewAEEventHandlerUPP((AEEventHandlerProcPtr)SCLQuit);
#else
	procODOC = NewAEEventHandlerProc(SCLOpenDoc);
	procOAPP = NewAEEventHandlerProc(SCLOpenApp);
	procPDOC = NewAEEventHandlerProc(SCLPrintDoc);
	procQUIT = NewAEEventHandlerProc(SCLQuit);
#endif

	err = AEInstallEventHandler(kCoreEventClass, kAEOpenDocuments, procODOC, 0, FALSE);
	err = AEInstallEventHandler(kCoreEventClass, kAEOpenApplication, procOAPP, 0, FALSE);
	err = AEInstallEventHandler(kCoreEventClass, kAEPrintDocuments, procPDOC, 0, FALSE);
	err = AEInstallEventHandler(kCoreEventClass, kAEQuitApplication, procQUIT, 0, FALSE);
}



void HandleAppleEvent(void)
{
EventRecord event;
OSErr err;
int i;

	for (i = 0; i < 10; i++)
	{
		if (WaitNextEvent(highLevelEventMask, &event, 10, 0))
		{
			s_dd.firstEvent = event;
			err = AEProcessAppleEvent(&event);
			break;
		}
	}
}


pascal OSErr SCLOpenDoc(AppleEvent *theAppleEvent,AppleEvent *reply,long handlerRefCon)
{
OSErr err;

	s_dd.appleEvent = *theAppleEvent;
	err = AEGetParamDesc(theAppleEvent,keyDirectObject,typeAEList,&s_dd.docList);
	err = AECountItems(&s_dd.docList,&s_dd.fileTotal);

	return noErr;
}

pascal OSErr SCLOpenApp(AppleEvent *theAppleEvent,AppleEvent *reply,long handlerRefCon)
{
	/* do nothing */
	return noErr;
}

pascal OSErr SCLPrintDoc(AppleEvent *theAppleEvent,AppleEvent *reply,long handlerRefCon)
{
	/* do nothing*/
	return noErr;
}

pascal OSErr SCLQuit(AppleEvent *theAppleEvent,AppleEvent *reply,long handlerRefCon)
{
	ExitToShell();
	return noErr;
}


#endif /*pragma once*/