/*
 *  s_Drawing.h
 *  Version 2.0 / 010910
 *  by Satoshi Takahashi
 */

#ifndef S_DRAWINGL_H /*pragma once*/
#define S_DRAWINGL_H
#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif

#if S_UNIX /* as s_Toolbox.h is not in parts-main */
#include <s_Toolbox.h>
#endif

#ifndef SCLLocal
#include <s_CarbonMacro.h>
#include <s_Carbon.h>
#else
#include "s_CarbonMacro.h"
#include "s_Carbon.h"
#endif

/***** Drawing *****/

extern	int				s_colorFlag;

extern	WindowPtr		s_drawingWindow;
extern	WindowPtr		s_displayWindow;
extern	Rect			s_windowBounds;
extern	WindowPtr		s_redrawWindow;
extern	Rect			s_redrawBounds;

extern double s_d_scale;

#if !S_UNIX /******************** !!!! UNIX ********************/
extern	GDHandle		s_devH;
extern	int				s_d_set;
extern	int				s_t_set;
extern	int				s_i_set;
extern	int				s_d_save;
extern	int				s_t_save;
extern	int				s_i_save;
extern	int				s_windowResFlag;
extern	void			(*RedrawWindowP)(void);
extern	Rect			s_drawingVisRect;
extern	GDHandle		s_display;

#endif /*!S_UNIX*/ /******************** UNIX ********************/

void	InitDrawing(void);
void	s_RedrawInitDrawing(void);
void	s_NoRedrawInitDrawing(void);

#if !S_UNIX /******************** !!!! UNIX ********************/

#if !S_CARBON
void	s_RedrawWindow(void);
#endif /*!S_CARBON*/
void	s_voidDummyVoid(void);

#define s_dRect (SCWindowBounds(s_drawingWindow))

#endif /*!S_UNIX*/ /******************** UNIX ********************/

#ifndef NO_REDRAW
#define DrawingWidth()	((int)(SCWindowBounds(s_redrawWindow)->right/s_d_scale))
#else /* ndef NO_REDRAW */
#define DrawingWidth()	((int)(SCWindowBounds(s_drawingWindow)->right))
#endif /* ndef NO_REDRAW */

#define DrawingHeight()	((int)(SCWindowBounds(s_drawingWindow)->bottom))

#if !S_UNIX /******************** !!!! UNIX ********************/

#ifdef NO_REDRAW

#define RedrawWindow()
#define RedrawDrawing()

#else /* def_NO_REDRAW */

#if !S_CARBON
#define RedrawWindow() s_RedrawWindow()
#define RedrawDrawing() RedrawWindow()
#endif /*!S_CARBON*/


#endif /* else_def_NO_REDRAW */
#endif /*!S_UNIX*/ /******************** UNIX ********************/

void ShowDrawing(void);
void HideDrawing(void);
void EraseDrawing(void);

#if !S_UNIX /******************** !!!! UNIX ********************/
void s_SetGWorld(GrafPtr port,GDHandle gdh);
void s_GetGWorld(GrafPtr* port,GDHandle* gdh);
#endif /*!S_UNIX*/ /******************** UNIX ********************/

void SetRGBColor(double r,double g,double b);

#endif /*pragma once*/
