/*
 *  s_Process.h
 *  Version 2.0 / 010910
 *  by Satoshi Takahashi
 *  most of codes are from UProcessUtils.p in ProcDoggie
 *  written by Forrest Tanaka
 *  copyright by Apple Computer
 */

#ifndef S_PROCESS_H /*pragma once*/
#define S_PROCESS_H

#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif

enum LaunchModeCode {kJustLaunch, kOpenLaunch, kPrintLaunch};

typedef int LaunchModeCode;

typedef struct DocListEntryRec
{
	struct DocListEntryRec **next;
	FSSpec	docFile;
} DocListEntryRec;
typedef DocListEntryRec *DocListEntryPtr, **DocListEntryHnd;

typedef struct DocListRec
{
			DocListEntryRec	**docList;
			LaunchModeCode	openPrint;
} DocListRec;
typedef 	DocListRec	*DocListPtr;
typedef 	DocListRec	**DocListHnd;

void LaunchOpen(FSSpec *appFileP, FSSpec *docFileP);
void Launch(FSSpec *appFileP);

DocListHnd CreateDocList(void);
Boolean IsEmptyDocList(DocListHnd theList);
OSErr AddToDocList(FSSpec *newFileP, DocListHnd theList);
void DisposeDocList(DocListHnd theList);
OSErr LaunchProcApp( FSSpec *processFileP,
                     DocListHnd docList,
					 LaunchFlags options);
OSErr CreateDocListDesc(DocListHnd theDocList,
	                            AEDesc *launchDescP);

int FindProcess(char *findName, ProcessSerialNumber *retPSN);
int FindProcessCreator(OSType creator, ProcessSerialNumber *retPSN);
int SPKillProcess(char *procName);
int SPKillProcessCreator(OSType procCreator);
int inSPKillProcess(char *procName, OSType procCreator);
int SPKillOldProcess(char *procName);

int LaunchOpenCreatorApp(OSType creator, FSSpec *docSpecP);
int FindAppFromCreator(OSType creator, FSSpec *appSpecP);


#endif /*pragma once*/